unit clMyBaseMediator;

interface

uses classes, fgl, sysutils, controls,  stdctrls;

type

TMyCollection = class
  fDisplayComponent : TControl;
  fClassname        : string;
  fOldValue         : string;
  fReadOnly         : boolean;
end;

Tmydictionary = specialize TFPGMap<string,TMyCollection>;

TMyBaseMediator = class
  private
    fcomponentList    : Tmydictionary;
    function locate(const aFieldname : string; var cln : TMycollection) : boolean;
  protected
    procedure mdread(const aFieldname: string; const aValue: variant);
  public
    constructor Create;
    destructor  Destroy; override;

    procedure AddComp(aCompname : TControl; const  aFieldname: string);
end;

implementation

constructor TMyBaseMediator.Create;
begin
  fcomponentList    := Tmydictionary.create;
end;

destructor TMyBaseMediator.Destroy;
begin
  fcomponentList.Free;
  inherited;
end;


procedure TMyBaseMediator.mdread(const aFieldname: string; const aValue: variant);
var cln : TMycollection;
begin
  cln := nil;
  if locate(aFieldname,cln) then
  begin
    if cln.fDisplayComponent is Tedit then
      TEdit(cln.fDisplayComponent).Text := aValue;
  end;
end;

procedure TMyBaseMediator.AddComp(aCompname : TControl; const  aFieldname: string);
var cln : TMyCollection;
begin
  cln := TMyCollection.Create;
  cln.fDisplayComponent := aCompname;
  cln.fClassname := aCompName.ClassName;
  fComponentlist.Add(aFieldname,cln);
end;

function TMyBaseMediator.locate(const aFieldname : string; var cln : TMycollection) : boolean;
begin
  result := fComponentlist.TryGetData(aFieldname,cln)
end;

end.
