unit clmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, clmainmediator, objWorld;

type

{ TMain }

 TMain = class
  strict private
    fMediator  : TMainMediator;
    fWorld     : TWorld;
  public
    constructor create;
    destructor  destroy;  override;

    procedure init;

    property Mediator : TMainMediator read fMediator;
end;

implementation

{ TMain }

constructor TMain.create;
begin
  fMediator  := TMainMediator.create;
  fworld     := TWorld.create;
end;

destructor TMain.destroy;
begin
  fworld.free;
  fMediator.free;
  inherited destroy;
end;

procedure TMain.init;
var country : Tcountry;
begin
  Country            := TCountry.create;
  Country.countryname:= 'the Netherlands';
  Country.capital    := 'Amsterdam';
  Country.population := '14 million';
  country.continent  := 'Europe';
  fWorld.Countrylist.Add(Country);
  fMediator.ReadToComp(fWorld.fcountrylist[0]);
end;

end.

