unit clMyBaseMediator;

interface

uses classes, fgl, sysutils, controls,  stdctrls;

type

TMyCollection = class
  fDisplayComponent : TControl;
  fClassname        : string;
  fOldValue         : string;
  fReadOnly         : boolean;
end;

Tmydictionary = specialize TFPGMap<string,TMyCollection>;

{ TMyBaseMediator }

TMyBaseMediator = class
  private
    fcomponentList    : Tmydictionary;
    function locate(const aFieldname : string; var cln : TMycollection) : boolean;
  protected
    procedure mdread(const aFieldname: string; const aValue: variant);

    function mdwrite(const aFieldname: string): variant;
  public
    constructor Create;
    destructor  Destroy; override;

    procedure Clear;
    procedure AddComp(aCompname : TControl; const  aFieldname: string);
end;

implementation

constructor TMyBaseMediator.Create;
begin
  fcomponentList    := Tmydictionary.create;
end;

destructor TMyBaseMediator.Destroy;
begin
  fcomponentList.Free;
  inherited;
end;

procedure TMyBaseMediator.mdread(const aFieldname: string; const aValue: variant);
var cln : TMycollection;
begin
  cln := nil;
  if locate(aFieldname,cln) then
  begin
    if cln.fDisplayComponent is Tedit then
      TEdit(cln.fDisplayComponent).Text := aValue
    else if cln.fDisplayComponent is TCombobox then
      Tcombobox(cln.fDisplayComponent).Text := aValue;
  end;
end;

function TMyBaseMediator.mdwrite(const aFieldname : string) :variant;
var cln : TMycollection;
begin
  if locate(aFieldname,cln) then
  begin
    if cln.fDisplayComponent is TEdit then
      result := TEdit(cln.fDisplayComponent).Text
    else if cln.fDisplayComponent is Tcombobox then
      result := TCombobox(cln.fDisplayComponent).Text;
  end;
end;

procedure TMyBaseMediator.AddComp(aCompname : TControl; const  aFieldname: string);
var cln : TMyCollection;
begin
  cln := TMyCollection.Create;
  cln.fDisplayComponent := aCompname;
  cln.fClassname := aCompName.ClassName;
  fComponentlist.Add(aFieldname,cln);
end;

function TMyBaseMediator.locate(const aFieldname : string; var cln : TMycollection) : boolean;
begin
  result := fComponentlist.TryGetData(aFieldname,cln)
end;

procedure TMyBaseMediator.Clear;
var cln : TMycollection;
    index : integer;
begin
  for index := 0 to fcomponentList.Count - 1 do
  begin
     cln := fComponentlist.Data[index];
     if cln.fDisplayComponent is TEdit then
       TEdit(cln.fDisplayComponent).Text := ''
     else if cln.fDisplayComponent is Tcombobox then
       Tcombobox(cln.fDisplayComponent).Text := '';
  end;
end;

end.
