unit clmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, stdctrls, clmainmediator, objWorld, objcontinent;

type

{ TMain }

 TMain = class
  strict private
    fMediator  : TMainMediator;
    fNewRecord : boolean;
    fWorld     : TWorld;
    function GetID: integer;
    function GetlastID: integer;
  public
    constructor create;
    destructor  destroy;  override;

    procedure init(aContinent : TStrings);
    procedure Save;
    procedure recordprior;
    procedure recordnext;
    procedure addrecord;
    procedure DeleteRecord;

    property Mediator : TMainMediator read fMediator;
    property NewRecord : boolean read fNewRecord write fNewRecord;
    property ID        : integer read GetID;
    property lastID    : integer read GetlastID;
end;

implementation

{ TMain }

uses dialogs;

constructor TMain.create;
begin
  fMediator  := TMainMediator.create;
  fworld     := TWorld.create;
end;

destructor TMain.destroy;
begin
  fworld.free;
  fMediator.free;
  inherited destroy;
end;

procedure TMain.init(aContinent: TStrings);
var fContinentTable : TContinentTable;
    Continent : TContinent;
begin
  fContinentTable := TContinentTable.create;
  try
  for continent in fContinentTable.Continentlist do
    aContinent.Add(continent.name);
  finally
     fContinentTable.free;
  end;
end;

procedure TMain.Save;
var Country : TCountry;
begin
  if fNewRecord then
  begin
    fWorld.IncreaseID;
    Country := TCountry.Create;
    Country.id := fWorld.LastID;
  end else
    Country := fWorld.FindRow;
  fMediator.CmpToWrite(Country);
  if fNewRecord then
  begin
    fWorld.Countrylist.Add(Country);
    fWorld.ID := fWorld.LastID;
    fNewRecord := false
  end;
end;

procedure TMain.recordprior;
var Country : TCountry;
begin
  if fWorld.ID > 0 then
  begin
    fWorld.ID := fWorld.ID - 1;
    Country := fWorld.FindRow;
    fMediator.ReadToComp(Country);
  end;
end;

procedure TMain.recordnext;
var Country : TCountry;
begin
  if fWorld.ID < fWorld.LastID then
  begin
    fWorld.ID := fWorld.ID + 1;
    Country := fWorld.FindRow;
    fMediator.ReadToComp(Country);
  end;
end;

procedure TMain.addrecord;
begin
  fMediator.Clear;
  fNewRecord := true;
end;

procedure TMain.DeleteRecord;
var country   : TCountry;
    emptylist : boolean;
begin
  emptylist := fWorld.RowDelete;
  if not fWorld.Error then
  begin
    if emptylist then
    begin
      country := fWorld.FindRow;
      fMediator.ReadToComp(country);
    end else
      AddRecord;
  end else
    showmessage('cannot delete item')
end;

function TMain.GetID: integer;
begin
  result := fWorld.ID;
end;

function TMain.GetlastID: integer;
begin
  result := fWorld.lastID;
end;

end.

