unit dConnection;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldblib, sqldb, sqlite3conn;

type

  { TDMConnection }

  TDMConnection = class(TDataModule)
    SQLConnector1: TSQLConnector;
    SQLDBLibraryLoader1: TSQLDBLibraryLoader;
    SQLTransaction1: TSQLTransaction;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private
    procedure CreateTables;

  public
    function DBConnection : TSQLConnector;
  end;

var
  DMConnection: TDMConnection;

implementation

{$R *.lfm}

{ TDMConnection }

procedure TDMConnection.DataModuleCreate(Sender: TObject);
var rootdir : string;
begin
 rootdir := extractfiledir(paramstr(0));
 SQLDBLibraryLoader1.LibraryName := rootdir + '\sqlite3.dll';
 SQLDBLibraryLoader1.Enabled := true;
 SQLConnector1.DatabaseName  := rootdir + '\world.db3';
 SQLConnector1.Connected := true;
 CreateTables;
end;

procedure TDMConnection.DataModuleDestroy(Sender: TObject);
begin
  SQLConnector1.Connected := false;
end;

procedure TDMConnection.CreateTables;
var MyTables : TStrings;
begin
  MyTables := TStringlist.create;
  try
    SQLConnector1.GetTableNames(MyTables);
    if MyTables.IndexOf('countries') = -1 then
    begin
      SQLConnector1.ExecuteDirect(
      'CREATE TABLE "countries" (' +
      '   "id" INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,' +
      '   "countryname" VARCHAR (30) NOT NULL,' +
      '   "capital" VARCHAR (40) NOT NULL,' +
      '   "population" VARCHAR (20) NOT NULL,' +
      '   "continent_id" INTEGER NOY NULL DEFAULT 0);');
      SQLConnector1.ExecuteDirect('CREATE UNIQUE INDEX "countries_id" ON "countries" ("id");');
      SQLTransaction1.commit;
    end;
  finally
    MyTables.free
  end;
end;

function TDMConnection.DBConnection: TSQLConnector;
begin
  result := SQLConnector1;
end;

end.

