unit objcontinent;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, fgl, objbase;

type

  TContinent = class
    id   : integer;
    name : string;
end;

TContinentlist = specialize TFPGObjectlist<TContinent>;

{ TContinentTable }

TContinentTable = class(TObjectBase)
  private
    fContinentlist : TContinentlist;
    procedure AddItem(const aID: integer; const aItem: string);
  public
    constructor create;
    destructor  destroy; override;

    property  Continentlist : TContinentlist read fContinentlist;
end;

implementation

{ TContinentTable }

constructor TContinentTable.create;
begin
  fContinentlist := TContinentlist.Create;
  AddItem(1,'Asia');
  AddItem(2,'North America');
  AddItem(3,'Autralia');
  AddItem(4,'Europe');
  AddItem(5,'South America');
  AddItem(6,'Africa');
  AddItem(7,'Antartica');
end;

destructor TContinentTable.destroy;
begin
  fContinentlist.free;
  inherited destroy;
end;

procedure TContinentTable.AddItem(const aID : integer; const aItem : string);
var continent : TContinent;
begin
  continent      := TContinent.Create;
  continent.id   := aID;
  continent.name := aItem;
  fContinentlist.Add(continent);
end;


end.

