unit fcity;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ActnList, ComCtrls,
  StdCtrls, clcity;

type

  { TFrmCity }

  TFrmCity = class(TForm)
    acBtnAdd: TAction;
    acBtnNext: TAction;
    acBtnPrior: TAction;
    acBtnSave: TAction;
    acDelete: TAction;
    ActionList1: TActionList;
    CBPopulation: TComboBox;
    CBTownship: TComboBox;
    CKCapital: TCheckBox;
    ECityname: TEdit;
    EMajor: TEdit;
    ESquare: TEdit;
    ESightseeing: TEdit;
    Label1: TLabel;
    LblTownship: TLabel;
    LblPopulation: TLabel;
    LblSquare: TLabel;
    LblSightseeing: TLabel;
    LblCityname: TLabel;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    procedure acBtnAddExecute(Sender: TObject);
    procedure acBtnAddUpdate(Sender: TObject);
    procedure acBtnNextExecute(Sender: TObject);
    procedure acBtnNextUpdate(Sender: TObject);
    procedure acBtnPriorExecute(Sender: TObject);
    procedure acBtnPriorUpdate(Sender: TObject);
    procedure acBtnSaveExecute(Sender: TObject);
    procedure acBtnSaveUpdate(Sender: TObject);
    procedure acDeleteExecute(Sender: TObject);
    procedure acDeleteUpdate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    flink : TFCity;
  public
    property Link : TFCity read flink;
  end;

implementation

{$R *.lfm}

{ TFrmCity }

procedure TFrmCity.FormCreate(Sender: TObject);
begin
  flink := TFCity.create;
  fLink.Mediator.AddComp(ECityname ,'cityname');
  fLink.Mediator.AddComp(EMajor ,'major');
  fLink.Mediator.AddComp(ESightseeing ,'sightseeing');
  fLink.Mediator.AddComp(ESquare ,'square');
  fLink.Mediator.AddComp(CKCapital,'capital');
  fLink.Mediator.AddComp(CBPopulation,'population');
  fLink.Mediator.AddComp(CBTownship,'township');
end;

procedure TFrmCity.FormShow(Sender: TObject);
begin
  flink.init(CBPopulation.Items, CBTownship.Items);

  if fLink.ID = -1 then
  begin
    flink.AddRecord;
    ECityname.SetFocus;
  end;
end;

procedure TFrmCity.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  flink.free;
end;

procedure TFrmCity.acBtnAddExecute(Sender: TObject);
begin
  flink.AddRecord;
  ECityname.SetFocus;
end;

procedure TFrmCity.acBtnAddUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := not flink.NewRecord;
end;

procedure TFrmCity.acBtnNextExecute(Sender: TObject);
begin
  flink.recordnext
end;

procedure TFrmCity.acBtnNextUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (not flink.NewRecord) and (flink.ID < flink.lastID);
end;

procedure TFrmCity.acBtnPriorExecute(Sender: TObject);
begin
  flink.recordprior
end;

procedure TFrmCity.acBtnPriorUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (not flink.NewRecord) and (flink.ID >= 0);
end;

procedure TFrmCity.acBtnSaveExecute(Sender: TObject);
begin
  flink.Save
end;

procedure TFrmCity.acBtnSaveUpdate(Sender: TObject);
begin
  //  TAction(Sender).Enabled := flink.lastID >= 0;
end;

procedure TFrmCity.acDeleteExecute(Sender: TObject);
begin
  flink.DeleteRecord;
  if fLink.ID = -1 then
  begin
    flink.AddRecord;
    ECityname.SetFocus;
  end;
end;

procedure TFrmCity.acDeleteUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (not flink.NewRecord) and (flink.ID >= 0);
end;

end.

