unit fmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,
  ActnList, ExtCtrls, Buttons, clmain;

type

  { TFrmMain }

  TFrmMain = class(TForm)
    acBtnAdd: TAction;
    acBtnPrior: TAction;
    acBtnNext: TAction;
    acBtnSave: TAction;
    acDelete: TAction;
    acCity: TAction;
    ActionList1: TActionList;
    CBContinent: TComboBox;
    ECapital: TEdit;
    ECountry: TEdit;
    EPopulation: TEdit;
    LblCapital: TLabel;
    LblContinent: TLabel;
    LblName: TLabel;
    LblPopulation: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    SpCities: TSpeedButton;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    procedure acBtnAddExecute(Sender: TObject);
    procedure acBtnAddUpdate(Sender: TObject);
    procedure acBtnNextExecute(Sender: TObject);
    procedure acBtnNextUpdate(Sender: TObject);
    procedure acBtnPriorExecute(Sender: TObject);
    procedure acBtnPriorUpdate(Sender: TObject);
    procedure acBtnSaveExecute(Sender: TObject);
    procedure acCityExecute(Sender: TObject);
    procedure acCityUpdate(Sender: TObject);
    procedure acDeleteExecute(Sender: TObject);
    procedure acDeleteUpdate(Sender: TObject);
    procedure CBContinentCloseUp(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private

  public
    flink : TMain;
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.lfm}

{ TFrmMain }

procedure TFrmMain.FormCreate(Sender: TObject);
begin
  flink := TMain.create;
  fLink.Mediator.AddComp(ECountry ,'countryname');
  fLink.Mediator.AddComp(ECapital,'capital');
  fLink.Mediator.AddComp(EPopulation,'population');
  fLink.Mediator.AddComp(CBContinent,'continent');
  flink.init(CBContinent.items);
end;

procedure TFrmMain.FormShow(Sender: TObject);
begin
  if fLink.ID = -1 then
  begin
    flink.AddRecord;
    ECountry.SetFocus;
  end;
end;

procedure TFrmMain.SpeedButton1Click(Sender: TObject);
begin
end;

procedure TFrmMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  flink.free
end;

procedure TFrmMain.acBtnAddExecute(Sender: TObject);
begin
  flink.AddRecord;
  ECountry.SetFocus;
end;

procedure TFrmMain.acBtnAddUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := not flink.NewRecord;
end;

procedure TFrmMain.acBtnNextExecute(Sender: TObject);
begin
  flink.recordnext
end;

procedure TFrmMain.acBtnNextUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (not flink.NewRecord) and (flink.ID < flink.lastID);
end;

procedure TFrmMain.acBtnPriorExecute(Sender: TObject);
begin
  flink.recordprior
end;

procedure TFrmMain.acBtnPriorUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (not flink.NewRecord) and (flink.ID >= 0);
end;

procedure TFrmMain.acBtnSaveExecute(Sender: TObject);
begin
  flink.Save
end;

procedure TFrmMain.acCityExecute(Sender: TObject);
begin
  flink.LoadCityForm
end;

procedure TFrmMain.acCityUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (not flink.NewRecord) and (flink.ID >= 0);
end;

procedure TFrmMain.acDeleteExecute(Sender: TObject);
begin
  flink.DeleteRecord;
  if fLink.ID = -1 then
  begin
    flink.AddRecord;
    ECountry.SetFocus;
  end;
end;

procedure TFrmMain.acDeleteUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (not flink.NewRecord) and (flink.ID >= 0);
end;

procedure TFrmMain.CBContinentCloseUp(Sender: TObject);
begin
  flink.lookupcontinent(CBContinent.Items[CBContinent.ItemIndex])
end;

end.

