unit clmainmediator;

{$mode objfpc}{$H+}

interface

uses classes, comctrls, clMyBaseMediator, objWorld;


type

{ TMainMediator }

 TMainMediator = class(TMyBaseMediator)
  private
  public
    procedure CmpToWrite(aCountry: TCountry);
    procedure ReadToComp(aCountry : TCountry);
    procedure ReadDetail(const aFieldname : string;
                         const aCountry_id : integer;
                         aList : TCityDetaillist);
end;


implementation


procedure TMainMediator.ReadToComp(aCountry : TCountry);
begin
  mdread('countryname',aCountry.name);
  mdread('capital',aCountry.capital);
  mdread('population',aCountry.population);
  mdread('continent',aCountry.continent);
end;

{new}
procedure TMainMediator.ReadDetail(const aFieldname : string;
                                   const aCountry_id: integer;
                                   aList : TCityDetaillist);
var cln        : TMycollection;
    LV         : TListview;
    ListItem   : TListItem;
    index      : integer;
    CityDetail : TCityDetail;

begin
  cln := nil;
  if locate(aFieldname,cln) then
  begin
    LV := TListview(cln.fDisplayComponent);
    try
      LV.BeginUpdate;
      LV.Clear;
      for index := 0 to aList.Count - 1 do
      begin
        CityDetail := aList[index];
        if aCountry_id = CityDetail.country_id then
        begin
          ListItem := LV.Items.Add;
          ListItem.Caption := CityDetail.cityname;
          ListItem.SubItems.Add(CityDetail.population);
          ListItem.SubItems.Add(CityDetail.townrange);
        end;
      end;
    finally
      LV.EndUpdate;
    end;
  end;
end;

procedure TMainMediator.CmpToWrite(aCountry : TCountry);
begin
  aCountry.name       := mdwrite('countryname');
  aCountry.capital    := mdwrite('capital');
  aCountry.population := mdwrite('population');
  aCountry.continent  := mdwrite('continent');
end;

end.

