unit objcity;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, fgl, objbase;

type
  TCity = class
    id           : integer;
    country_id   : integer;
    cityname     : string;
    major        : string;
    capital      : boolean;
    sightseeing  : string;
    square       : integer;
    poprange_id  : integer; //for database purpose
    population   : string;
    township_id  : integer; //for database purpose
    township     : string;
  end;

TCitylist = specialize TFPGObjectList<TCity>;

{ TCities }

TCities = class(TObjectBase)
  fCitylist : TCitylist;
private
  procedure Reindex;
  public
    constructor create;
    destructor  destroy; override;

    function FindRow : TCity;
    function RowDelete  : boolean;

    procedure IncreaseID;

    property Citylist : TCitylist read fCitylist;
end;


implementation

{ TCities }

constructor TCities.create;
begin
  fCitylist := TCitylist.create;
end;

destructor TCities.destroy;
begin
  fCitylist.free;
  inherited destroy;
end;

procedure TCities.IncreaseID;
begin
  fLastID := FLastID + 1;
  fID     := fLastID;
end;

procedure TCities.Reindex;
var City    : TCity;
    index   : integer;
begin
  for index := 0 to fCitylist.Count - 1 do
  begin
    City := fCitylist[index];
    City.id := index;
    flastid := index;
  end;
end;

function TCities.FindRow: TCity;
begin
  try
    if assigned(fCitylist) then
    begin
      if (fCitylist.Count > 0) and (fID >= 0) then
        result := fCitylist[fID]
    end else
      result := nil;
    except
      result := nil;
  end;
end;

function TCities.RowDelete: boolean;
var myID : integer;
begin
  try
    fError := false;
    myID := fID;
    fCitylist.Delete(fID);
    fCitylist.Pack;
    if fCitylist.Count = 0 then
    begin
      result := false;
      fID := -1;
    end  else
    begin
      if myID = fLastID then
      begin
        myID := myID - 1;
        if myID = -1 then
        begin
          fID := -1;
          result := false;
        end else
        begin
          fID := fID - 1;
          result := true;
        end;
      end else if myID = 0 then
      begin
        fID := -1;
        result := false;
      end else if myID < fLastID then
      begin
        result := true;
      end;
    end;
    Reindex;
  except
    fError := true
  end;
end;

end.

